clear
clc

device = serialport("COM13",9600);
device.Timeout = 60;
[x,y,z,Bx,By,Bz] = deal([]);

while(1)
    try
        data = char(readline(device));
        RD = str2num(data(1:end-1));
        if(isempty(RD))
            error;
        else
            x = [x RD(1)];
            y = [y RD(2)];
            z = [z RD(3)]; 
            Bx = [Bx RD(4)];
            By = [By RD(5)];
            Bz = [Bz RD(6)];
        end
    catch
        break;
    end
end

figure(1);
plot3(Bx,By,Bz);
xlabel('X (in)');
ylabel('Y (in)');
zlabel('Z (in)');
xlim([-20,20]);
ylim([-20,20]);
zlim([-20,20]);
box on;
grid on;
clear device;